from pydicom import dcmread
from os import walk, path, mkdir, getcwd
from shutil import copy2 


i=0
FoundFiles=[]
FoundFiles_DICOMDIR=[]
FoundFiles_PatientID={}

for root, dirs, files in walk("../ex_DICOM", topdown = False):
	for name in files: 
		i=i+1
		dicom_file=path.join(root, name)
		try:
			dicomMeta = dcmread(dicom_file)
			if not("DirectoryRecordSequence" in dicomMeta):
				#print(dicomMeta.PatientName)
				FoundFiles_PatientID[dicom_file]= str(dicomMeta.PatientName)
				print(format(i,'02d') + ':' + name  + ': Patient:' + str(dicomMeta.PatientName))
			if name.endswith('DICOMDIR'):
				path, filename = path.split(dicom_file)
				FoundFiles_DICOMDIR.append(path)
				print( dicom_file + "-->  Skipped (cause DICOMDIR) " + str(files))
		except InvalidDicomError as exc:
			print( dicom_file + "-->  Skipped (cause NO DICOM)")
#print('FoundFiles_DICOMDIR:' + str(FoundFiles_DICOMDIR))


for Foundfiles in FoundFiles_PatientID:
    dicomMeta = dcmread(Foundfiles)
    #targetdir = path.join(getcwd(), "../ex_DICOM_sorted/" + FoundFiles_PatientID[dicom_file])
    targetdir = path.join(getcwd(), "../ex_DICOM_sorted/" )
    if not path.exists(targetdir):
        mkdir(targetdir)
    print("From :" + Foundfiles + '--> To:' + targetdir)
    head_tail = path.split(Foundfiles)
    copy2(Foundfiles,path.join(targetdir,str(dicomMeta.PatientName) + '_' + str(dicomMeta.AcquisitionDateTime) + '_' + head_tail[1]))

